/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

package jp.co.ntt.lms.Common.RDF;

import java.io.Serializable;

/**
 * RDFノードクラス
 * RDFファイル形式のrdfノードをあらわします。
 * @author T.Nijou
 * @version 0.0.0.1 2004/01/08
 */
public class RDFNode implements Serializable{

	/**
	 * ノードタイプが指定されていない場合
	 */
	public static final int UNKNOWN_NODE = 0;

	/**
	 * コースノードをあらわします
	 */
	public static final int COURSE_NODE = 1;

	/**
	 * ブロックノードをあらわします
	 */
	public static final int BLOCK_NODE = 2;

	/**
	 * AUノードをあらわします
	 */
	public static final int AU_NODE = 3;

	/**
	 * タイトルを保持します
	 */
	private String mstrTitle = "";

	/**
	 * AUsystemIDを保持します
	 */
	private String mstrAUsystemID = "";

	/**
	 * IDを保持します
	 */
	private String mstrID = "";

	/**
	 * 教材IDを保持します
	 */
	private String mstrMaterialID = "";

	/**
	 * バージョンを保持します
	 */
	private String mstrVersion = "";

	/**
	 * オーダーを保持します
	 */
	private int mstrOrder = 0;

	/**
	 * ノードタイプを保持します<BR>
	 * <PRE>
	 * 		ノードタイプ
	 *			COURSE_NODE コースノード
	 *			BLOCK_NODE	ブロックノード
	 *			AU_NODE		AUノード
	 * </PRE>
	 */
	private int mintNodeType = UNKNOWN_NODE;

	/**
	 * 親ノードを保持します
	 */
	private RDFNode mobjParentNode = null;

	/**
	 *	子ノードリストを保持します
	 */
	private RDFNodeList mobjNodeList = new RDFNodeList();

	/**
	 * コンストラクタです
	 */
	public RDFNode() {
	}

	/**
	 * 親ノードを設定します
	 * @param objParentNode 親ノード
	 */
	public void setParentNode( RDFNode objParentNode ) {
		mobjParentNode = objParentNode;
	}

	/**
	 * 親ノードを取得します
	 * @return RDFNode 親ノード
	 */
	public RDFNode getParentNode() {
		return mobjParentNode;
	}

	/**
	 * 子ノードを追加します
	 * @param objNode 子ノード
	 */
	public void addChild( RDFNode objNode ) {
		if( objNode != null ) {
			mobjNodeList.add( objNode );
		}
	}

	/**
	 * 子ノードリストを取得します
	 * @return RDFNodeList 子ノードリスト
	 */
	public RDFNodeList getChildNodes() {
		return mobjNodeList;
	}

	/**
	 * ノードタイプを設定します
	 * @param intNodeType ノードタイプ
	 * <PRE>
	 *      ノードタイプには以下のものがあります
	 *          COURSE_NODE     コースノード
	 *          BLOCK_NODE      ブロックノード
	 *          AU_NODE         AUノード
	 * </PRE>
	 * @exception RDFUnknownNodeTypeException ノードタイプが不正の場合
	 */
	public void setNodeType( int intNodeType )
		throws RDFUnknownNodeTypeException
	{

		if( intNodeType != COURSE_NODE &&
			intNodeType != BLOCK_NODE &&
			intNodeType != AU_NODE )
		{
			// ノードタイプが不正の場合
			throw new RDFUnknownNodeTypeException( intNodeType );
		}


		mintNodeType = intNodeType;
	}

	/**
	 * ノードタイプを取得します
	 */
	public int getNodeType() {
		return mintNodeType;
	}

	/**
	 * タイトルを設定します
	 * @param strTitle タイトル
	 */
	public void setTitle( String strTitle ) {
		mstrTitle = strTitle;
	}

	/**
	 * タイトルを取得します
	 * @return String タイトル
	 */
	public String getTitle() {
		return mstrTitle;
	}
	/**
	 * AUsystemIDを設定します
	 * @param strTitle AUsystemID
	 */
	public void setAUsystemID( String strAUsystemID ) {
		mstrAUsystemID = strAUsystemID;
	}

	/**
	 * AUsystemIDを取得します
	 * @return String AUsystemID
	 */
	public String getAUsystemID() {
		return mstrAUsystemID;
	}

	/**
	 * IDを設定します
	 * @param strID ID
	 */
	public void setID( String strID ) {
		mstrID = strID;
	}

	/**
	 * IDを取得します
	 * @return String ID
	 */
	public String getID() {
		if( mstrID.indexOf( ':' ) > 0 ) {
			return mstrID.substring( mstrID.indexOf( ':' ) + 1, mstrID.length() );
		}

		return mstrID;
	}

	/**
	 * 設定されているIDをUIDとして取得します
	 * @return String UID
	 */
	public String getUid() {
		return mstrID;
	}

	/**
	 * 教材IDを設定します
	 * @param strMaterialID 教材ID
	 */
	public void setMaterialID( String strMaterialID ) {
		mstrMaterialID = strMaterialID;
	}

	/**
	 * 教材IDを取得します
	 * @return String 教材ID
	 */
	public String getMaterialID() {
		return mstrMaterialID;
	}

	/**
	 * バージョンを設定します
	 * @param strVersion バージョン
	 */
	public void setVersion( String strVersion ) {
		mstrVersion = strVersion;
	}

	/**
	 * バージョンを取得します
	 * @return String バージョン
	 */
	public String getVersion() {
		return mstrVersion;
	}

	/**
	 * オーダーを設定します
	 * @param strOrder オーダー
	 */
	public void setOrder( int strOrder ) {
		mstrOrder = strOrder;
	}

	/**
	 * オーダーを取得します
	 * @return int オーダー
	 */
	public int getOrder() {
		return mstrOrder;
	}

	/**
	 * 指定されたIDのノードを配下の子ノードから検索します。<BR>
	 * @param strID 検索ID
	 */
	public RDFNode searchNode( String strID ) {
		RDFNode objNodeTemp = null;
		for( int i = 0; i < mobjNodeList.getLength(); i++ ) {
			objNodeTemp = mobjNodeList.getNode(i);
			if( objNodeTemp.getID().equals( strID ) ) {
				return objNodeTemp;
			}
			else {
				RDFNode objChildNode = objNodeTemp.searchNode( strID );
				if( objChildNode != null ) {
					return objChildNode;
				}
			}
		}
		return null;
	}

	/**
	 * 指定されたシステムIDのノードを配下の子ノードから検索します。<BR>
	 * @param strID 検索ID
	 */
	public RDFNode searchNodeFromSystemID( String strSystemID ) {
		RDFNode objNodeTemp = null;
		for( int i = 0; i < mobjNodeList.getLength(); i++ ) {
			objNodeTemp = mobjNodeList.getNode(i);
			if( objNodeTemp.getAUsystemID().equals( strSystemID ) ) {
				return objNodeTemp;
			}
			else {
				RDFNode objChildNode = objNodeTemp.searchNodeFromSystemID( strSystemID );
				if( objChildNode != null ) {
					return objChildNode;
				}
			}
		}
		return null;
	}


}




